/* 
 * Motif Tools Library, Version 3.1
 * $Id: XmtP.h.in,v 1.1 2001/09/19 02:57:18 grmcdorman Exp $
 * 
 * Written by David Flanagan.
 * Copyright (c) 1992-2001 by David Flanagan.
 * All Rights Reserved.  See the file COPYRIGHT for details.
 * This is open source software.  See the file LICENSE for details.
 * There is no warranty for this software.  See NO_WARRANTY for details.
 *
 * $Log: XmtP.h.in,v $
 * Revision 1.1  2001/09/19 02:57:18  grmcdorman
 * This change makes the following modifications:
 *   A new program, printConfig, is provided. This is built by a
 *   simple rule in the Makefile and not installed. It prints
 *   significant defines from Xmt.tmpl.
 *
 *   XmtP.h is now generated from XmtP.h.in using printConfig. As
 *   a result, code compiled outside of the Xmt Imakefiles will
 *   have all of the Xmt.tmpl defines.
 *
 *   Source files are modified to use XmtP.h instead of Xmt.h.
 *
 *   WorkingBox.c is modified to use the new Progress widget.
 *   It can be compiled in the old style if WORKINGBOX_USE_SCALE is
 *   defined at compile time.
 *
 *   Because XmtP.h is generated dynamically, it is removed from CVS
 *   with this check-in.
 *
 * Revision 1.1.1.1  2001/02/10 13:52:09  motiftools
 * Initial import of Xmt310 to CVS
 *
 *
 */

#ifndef _XmtP_h
#define _XmtP_h

/*
 * Configuration defines. These are based on values in Xmt.tmpl in the build.
 */
/* #undef NO_MEMMOVE */
#undef XMT_HAS_STRERROR
#define XMT_HAS_STRERROR
/* #undef XMT_HAS_SYS_ERRLIST */
/* #undef XMTSTRING_TO_COMPOUND_TEXT_BUG */
/* #undef BACKSPACEBUG */
/* #undef HP_NLS */
/* #undef DECWINDOWS */
/* #undef DECWINDOWS_CALLBACK_HACK */
/* #undef VMS */
/* #undef IBM_MANAGE_WORKAROUND */
/* #undef MISSING_METHOD_TYPES */
/* #undef NUTCRACKER_BUG_WORKAROUND */
/* #undef DISABLE_INPUTFIELD_DRAGDROP */
/* #undef XMT_HAS_XMTPP */

/*
 * This header includes XmP.h and fixes problems with it
 * and handles 1.1 to 1.2 portability issues
 */

#include <Xmt/Xmt.h>
#include <Xm/XmP.h>

#if XmVersion == 1001
#include <Xm/Traversal.h>
#endif

#if XmVersion >= 1002
#include <Xm/PrimitiveP.h>
#include <Xm/GadgetP.h>
#include <Xm/ManagerP.h>
#endif

#if !defined (XMT_HAS_STRERROR)
# if defined (XMT_HAS_SYS_ERRLIST)
extern char *sys_errlist[];
#   define strerror(err) sys_errlist[err]
# else
#   define strerror(err) "strerror is unsupported"
# endif /* XMT_HAS_SYS_ERRLIST */
#endif /* !XMT_HAS_STERROR */

/*
 * DECWindows can't handle XtRemoveCallback, so we make these patches:
 */
#ifdef DECWINDOWS_CALLBACK_HACK
#define XtAddCallback _XmtDECAddCallback
#define XtRemoveCallback _XmtDECRemoveCallback
#if NeedFunctionPrototypes
extern void _XmtDECAddCallback(Widget, String, XtCallbackProc, XtPointer);
extern void _XmtDECRemoveCallback(Widget, String, XtCallbackProc, XtPointer);
#else
extern void _XmtDECAddCallback();
extern void _XmtDECRemoveCallback();
#endif
#endif

/*
 * Some systems (e.g. SunOS 4.1.3_U1) still don't have memmove()
 */
#ifdef NO_MEMMOVE
#undef memmove
#define memmove(a,b,n) bcopy(b,a,n)
#endif

/*
 * In Unix, app-defaults files have the suffix ".ad".  In VMS
 * they have the suffix ".dat".  We define a symbolic constant
 * to take care of this difference and use it in ContextHelp.c
 * and Include.c
 */
#ifndef APPDEFAULTSSUFFIX
#ifndef VMS
#define APPDEFAULTSSUFFIX ".ad"
#else
#define APPDEFAULTSSUFFIX ".dat"
#endif
#endif


#if XmVersion == 1001
/* XmP.h uses NULL instead of None, resulting in a compiler warning */
#ifdef XtIsRealized
#undef XtIsRealized
#endif
#define XtIsRealized(widget) 					\
   (XtIsWidget(widget)  ?					\
      ((Widget)(widget))->core.window != None  :		\
      ((Object)(widget))->object.parent->core.window != None)

#endif  /* XmVersion 1001 */

/*
 * In Motif 1.1.0, and maybe other old 1.1 versions as well,
 * XmMenuProc and other XmRowColumn method types are not defined.
 * If needed, we define them here.
 */
#ifdef MISSING_METHOD_TYPES
#define XmMenuProc XtProc
#define XmArmAndActivate XtProc
#define XmMenuTrav XtProc
#endif

/*
 * Inheritance symbols not defined in Motif 1.1
 */
#if XmVersion == 1001
/* HP Motif does these inheritance symbols a little differently */
#if defined(HP_MOTIF) || defined(HP_NLS)
#ifndef XmInheritArmAndActivate
#define XmInheritArmAndActivate (XtActionProc) _XtInherit
#endif    
#ifndef  XmInheritMenuTraversalProc
#define  XmInheritMenuTraversalProc (XmMenuTraversalProc) _XtInherit
#endif    
#else  /* if not HP/Motif */
#ifndef XmInheritArmAndActivate
#define XmInheritArmAndActivate    (XmArmAndActivate) _XtInherit
#endif    
#ifndef XmInheritMenuTraversalProc
#define XmInheritMenuTraversalProc (XmMenuTrav) _XtInherit
#endif    
#ifndef XmInheritFocusMovedProc
#define XmInheritFocusMovedProc XtInheritFocusMovedProc
#endif    
#endif
#ifndef XmInheritMenuProc
#define XmInheritMenuProc          (XmMenuProc) _XtInherit
#endif    
#ifndef XmInheritBorderHighlight
#define XmInheritBorderHighlight   (XtWidgetProc) _XtInherit
#endif    
#ifndef XmInheritBorderUnhighlight
#define XmInheritBorderUnhighlight (XtWidgetProc) _XtInherit
#endif    
#endif

/*
 * An inheritance symbol omited from 1.2.0
 */
#if XmVersion == 1002
#ifndef XmInheritMenuTraversalProc    
#define XmInheritMenuTraversalProc (XmMenuTraversalProc) _XtInherit
#endif    
#endif

/*
 * Some internal functions' signatures changed between 1.1 and 1.2,
 * so define some wrapper macros that work correctly for either release.
 */
#if XmVersion <= 1001
#define _XmtConfigureObject(g, x, y, w, h, b)\
    _XmConfigureObject((RectObj)g, x, y, w, h, b)
#define _XmtResizeObject(g, w, h, bw) _XmResizeObject((RectObj)g, w, h, bw);
#define _XmtMoveObject(g, x, y) _XmMoveObject((RectObj)g, x, y);
#define _XmtRedisplayGadgets(w, e, r)\
    _XmRedisplayGadgets((CompositeWidget)w, (XExposeEvent *)e, r)
#else
#define _XmtConfigureObject(g,x,y,w,h,b) _XmConfigureObject(g, x, y, w, h, b)
#define _XmtResizeObject(g, w, h, bw) _XmResizeObject(g, w, h, bw);
#define _XmtMoveObject(g, x, y) _XmMoveObject(g, x, y);
#define _XmtRedisplayGadgets(w, e, r) _XmRedisplayGadgets(w, e, r)
#endif

#if XmVersion >= 2000
/*
 * ARH  These functions have been removed from view in Motif 2.0.
 *      Suitable replacements need to be provided, but this will
 *      get us going.
 */
extern void _XmTextMarginsProc(Widget w, XmBaselineMargins *margins_rec) ;

extern void _XmDestroyParentCallback(Widget w, XtPointer client_data,
				     XtPointer call_data) ;
#endif


    
#endif /* _XmtP_h */
